/*
 * Copyright 2007-2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib;

import org.globus.gridshib.gt.authorization.PIP;
import org.globus.gridshib.gt.authorization.SAMLAssertionPushPIPImpl;

/**
 * This PIP traverses the certificate chain presented by the
 * requester, extracts any SAML assertions bound to the
 * certificates in the chain, and updates the security
 * context with the security information extracted from
 * the bound assertions.
 *
 * @see org.globus.gridshib.gt.authorization.SAMLAssertionPushPIPImpl
 */
public class SAMLAssertionPushPIP extends BasePIP {

    protected SAMLAssertionPushPIPImpl impl = null;

    protected PIP pipImpl() {
        if (this.impl == null) {
            this.impl = new SAMLAssertionPushPIPImpl();
        }
        return this.impl;
    }
}
