/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib;

import org.globus.gridshib.gt.authorization.SAMLBlacklistPDPImpl;
import org.globus.gridshib.gt.authorization.PDP;

/**
 * This PDP makes an access control decision based on
 * information from the user's security context.  If
 * an IP address or principal name identifier from the
 * security context is on a preconfigured blacklist,
 * the request is denied.
 *
 * @see org.globus.gridshib.BasePDP
 * @see org.globus.gridshib.gt.authorization.SAMLBlacklistPDPImpl
 */
public class SAMLBlacklistPDP extends BasePDP {

    protected SAMLBlacklistPDPImpl impl = null;

    protected PDP pdpImpl() {
        if (this.impl == null) {
            this.impl = new SAMLBlacklistPDPImpl();
        }
        return this.impl;
    }

}
