/*
 * Copyright 2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib.gt.authorization;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

/**
 * A base implementation of the GS4GT PDP interface.
 */
public abstract class BasePDP implements PDP {

    private Set names = new HashSet();

    public boolean isInitialized(String name) {
        return names.contains(name);
    }

    /**
     * If a subclass overrides this method (which
     * is almost always the case), it MUST call
     * this method at the end of a successful
     * initialization.
     */
    public void initialize(HashMap configs,
                           String name) throws Exception {
        names.add(name);
    }
}
