/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */
package org.globus.gridshib.gt.authorization;

import javax.xml.namespace.QName;

import org.globus.gridshib.gt.authorization.GridShibConfigParams;
import org.globus.opensaml11.saml.XML;

public interface ShibbolethConstants extends GridShibConfigParams {

    /**
     * A default IdP <code>entityID</code>
     * used in the system tests.
     */
    public static final String DEFAULT_IDP_PROVIDER_ID =
        "urn:mace:inqueue:example.org";

    /**
     * A default SP <code>entityID</code>
     * used in the system tests.
     */
    public static final String DEFAULT_SP_PROVIDER_ID =
        "urn:mace:inqueue:example.org";

    // true constants
    public static final String SAMLP_1_0 = XML.SAMLP_NS;
    public static final String SAMLP_1_1 = XML.SAML11_PROTOCOL_ENUM;
    public static final QName SAMLP_1_0_SUCCESS =
            new QName(SAMLP_1_0, "Success");
    public static final QName SAMLP_1_1_SUCCESS =
            new QName(SAMLP_1_1, "Success");
    public static final QName SAMLP_1_0_RESPONDER =
            new QName(SAMLP_1_0, "Responder");
    public static final QName SAMLP_1_1_RESPONDER =
            new QName(SAMLP_1_1, "Responder");

    // to load VOMS interceptors via Class.forName
    public static final String VOMS_PIP =
        "org.globus.voms.impl.VomsCredentialPIP";
    public static final String VOMS_PDP =
        "org.globus.voms.impl.VomsPDP";

    /**
     * JNDI subcontexts for attribute information hashmap
     */
    public static final String ATTRIBUTE_MAP = "attributemap";

    //this is so other things can be associated
    public static final String ATTRIBUTE_MAP_KEY = "store";

    public static final String CACHE_DEFAULT = "/defaultcache";
}

