/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib.gt.authorization.samlpiputils;

import java.security.cert.X509Certificate;

/**
 * Wraps X509Certificate with file it came from.
 */
public class Cert {
    private String absolutePath;
    private X509Certificate cert;

    public Cert(String absolutePath, X509Certificate cert) {
        this.absolutePath = absolutePath;
        this.cert = cert;
    }

    public String getAbsolutePath() {
        return absolutePath;
    }

    public X509Certificate getCert() {
        return cert;
    }
}
