/*
 * Copyright 2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.globus.gridshib.gt.security;

/**
 * A username principal used throughout GS4GT.
 *
 * @see org.globus.gsi.jaas.UserNamePrincipal
 */
public class UserNamePrincipal extends org.globus.gsi.jaas.UserNamePrincipal {

    // This class works around a Globus bug:
    //
    // http://bugzilla.globus.org/globus/show_bug.cgi?id=5981
    //
    // Since org.globus.gsi.jaas.UserNamePrincipal does not
    // override the equals method of its superclass, we do
    // so here.

    public UserNamePrincipal(String name) {
        super(name);
    }

    /**
     * Instances of this class and class
     * org.globus.gsi.jaas.UserNamePrincipal
     * belong to the same equivalence class.
     */
    public boolean equals(Object o) {

        if (!(o instanceof org.globus.gsi.jaas.UserNamePrincipal)) {
            return false;
        }

        String name = ((org.globus.gsi.jaas.UserNamePrincipal)o).getName();
        if (this.getName() == null) {
            return (this.getName() == name);
        } else {
            return this.getName().equals(name);
        }
    }
}
