/*
 * Copyright 2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib.gt.authorization.attributes.tests.util;

import javax.xml.rpc.ServiceException;
import javax.xml.rpc.Stub;

import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI;
import org.apache.axis.types.URI.MalformedURIException;

import org.globus.gridshib.gt.authorization.attributes.tests.service.generated.ShibbolethTestPortType;
import org.globus.gridshib.gt.authorization.attributes.tests.service.generated.ShibbolethTestServiceAddressingLocator;

import org.globus.wsrf.impl.security.authentication.Constants;

public class CompatibleUtil {

    public static ShibbolethTestPortType getTestPort(String testAddr,
                                                     Object authorization)
                                              throws MalformedURIException,
                                                     ServiceException {

        String msg = "Shibboleth Protected Test Service: " + testAddr;
        System.out.println("- " + msg);

        EndpointReferenceType testServiceEPR =
            new EndpointReferenceType(new URI(testAddr));

        ShibbolethTestServiceAddressingLocator locator1 =
            new ShibbolethTestServiceAddressingLocator();
        ShibbolethTestPortType testPort1 =
            locator1.getShibbolethTestPortTypePort(testServiceEPR);

        ((Stub)testPort1)._setProperty(Constants.AUTHORIZATION, authorization);

        return testPort1;
    }
}
