/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib.gt.authorization.attributes.tests.echoservice;

import org.apache.axis.MessageContext;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.globus.gridshib.gt.authorization.attributes.tests.echoservice.generated.EchoRequest;
import org.globus.gridshib.gt.security.GS4GTSecurityContext;

import javax.security.auth.Subject;
import java.rmi.RemoteException;

public class SecurityContextEchoService {

    static Log logger =
            LogFactory.getLog(SecurityContextEchoService.class.getName());

    public String echo(EchoRequest req) throws RemoteException {
        StringBuffer buf = new StringBuffer();

        MessageContext ctx = MessageContext.getCurrentContext();

        if (ctx == null) {
            String msg = "No message context associated with thread. Peer "
                        + " credentials unavailable";
            logger.warn(msg);
            buf.append(msg);
        } else {

            Subject peer =
                (Subject)ctx.getProperty(org.globus.wsrf.impl.security
                                         .authentication
                                         .Constants.PEER_SUBJECT);

            if (peer != null) {
                GS4GTSecurityContext secCtx =
                    GS4GTSecurityContext.getGS4GTSecurityContext(peer);
                buf.append(secCtx.toString());
            } else {
                String msg = "No peer found";
                logger.warn(msg);
                buf.append(msg);
            }
        }

        String ret = buf.toString();
        logger.debug(ret);

        return ret;
    }
}
