/*
 * Copyright 2007-2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib;

import org.globus.gridshib.gt.authorization.PDP;
import org.globus.gridshib.gt.authorization.GS4GT.PullPDPImpl;

/**
 * This GT&nbsp;4.0 combined interceptor makes an access
 * control decision based on pulled attributes.  It is
 * backed by an instance of <code>GS4GT.PullPDPImpl</code>.
 * The {@link BasePDP#isPermitted(Subject, MessageContext, QName)}
 * method of the superclass
 * returns <code>true</code> if and only if
 * {@link PullPDPImpl#isPermitted(Subject, MessageContext, QName)}
 * returns <code>PDPDecision.PERMIT</code>.
 *
 * @see org.globus.gridshib.BasePDP
 * @see org.globus.gridshib.gt.authorization.GS4GT.PullPDPImpl
 */
public class GridShibPullPDP extends BasePDP {

    protected PullPDPImpl impl = null;

    protected PDP pdpImpl() {
        if (this.impl == null) {
            this.impl = new PullPDPImpl();
        }
        return this.impl;
    }
}
