/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib;

import org.globus.gridshib.gt.authorization.PIP;
import org.globus.gridshib.gt.authorization.SAMLMapPIPImpl;

/**
 * This PIP maps attributes from the user's security context
 * into one or more local accounts.  It then updates the
 * security context with this mapping information (similar to
 * grid-mapfile but for SAML attributes instead of DNs).
 *
 * @see org.globus.gridshib.gt.authorization.SAMLMapPIPImpl
 */
public class SAMLMapPIP extends BasePIP {

    protected SAMLMapPIPImpl impl = null;

    protected PIP pipImpl() {
        if (this.impl == null) {
            this.impl = new SAMLMapPIPImpl();
        }
        return this.impl;
    }
}
