/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib.gt.authorization.samlpiputils;

import org.apache.axis.types.URI;

public class GridSP {

    private URI resourceAttr = null;
    private String SPproviderId = null;

    public GridSP(URI resourceAttr, String SPproviderId) {
        this.resourceAttr = resourceAttr;
        this.SPproviderId = SPproviderId;
    }

    /**
     *       <samlp:AttributeQuery
     *              Resource="https://gs.org/shibboleth">
     *              <!-- Grid Service providerId -->
     *
     * @return URI
     */
    public URI getResourceURI() {
        return resourceAttr;
    }


    public String getSPproviderId() {
        return SPproviderId;
    }
}
