/*
 * Copyright 2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.globus.gridshib.gt.security;

import org.globus.gsi.jaas.SimplePrincipal;

/**
 * A simple SAML principal.  Corresponds to an
 * unqualified SAML name identifier string value.
 *
 * @see org.globus.gsi.jaas.SimplePrincipal
 */
public class SAMLPrincipal extends SimplePrincipal {

    public SAMLPrincipal(String name) {
        super(name);
    }

    public boolean equals(Object o) {

        if (!(o instanceof SAMLPrincipal)) {
            return false;
        }

        String name = ((SAMLPrincipal)o).getName();
        if (this.getName() == null) {
            return (this.getName() == name);
        } else {
            return this.getName().equals(name);
        }
    }
}
