/*
 * Copyright 2008 University of Illinois
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package org.globus.gridshib.gt.authorization.samlpiputils;

import javax.xml.rpc.ServiceException;

import org.apache.axis.types.URI.MalformedURIException;

import org.globus.axis.message.addressing.Address;
import org.globus.axis.message.addressing.EndpointReferenceType;

import org.globus.samlAttributeRequest.generated.SAMLAttributeRequestPortType;
import org.globus.samlAttributeRequest.generated.SAMLAttributeServiceAddressingLocator;

public class CompatibleUtil {

    public static SAMLAttributeRequestPortType getPort(String aaURL)
                                                throws MalformedURIException,
                                                       ServiceException {

        SAMLAttributeServiceAddressingLocator locator =
            new SAMLAttributeServiceAddressingLocator();
        EndpointReferenceType endpoint = new EndpointReferenceType();
        endpoint.setAddress(new Address(aaURL));

        return locator.getSAMLAttributeRequestPortTypePort(endpoint);
    }
}
