/*
 * Copyright 1999-2008 University of Chicago
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */
package org.globus.gridshib.gt.authorization.attributes.tests;

public interface AttributeTestConstants {
    public static final String SHIB_PROTECTED_SERVICE_PATH = "ShibbolethTestService";
    public static final String TEST_ATTRIBUTE_AUTHORITY = "TestAttributeAuthority";

    public static final String TEST_ATTRIBUTE_AUTHORITY_IDENTITY =
        "TEST_ATTRIBUTE_SERVICE_IDENTITY";

    public static final String DN = "DN";

    /**
     * JNDI path appended to TEST_ATTRIBUTE_AUTHORITY service path when
     * looking up the AA's service's authz information
     */
    public static final String CONTROL_NAME =
        "/aacontrol";

    public static final String[] USERNAME_LIST = { "tester", "foo", "bar" };

    public static final int USERNAME_TEST_CODE = 1;

}
